# BomberNyan API

## Getting Started

First, install php8 and composer, then clone the repository. You should now copy `.env.example` to `.env` and make the required edits.
The example configuration should work out of the box and uses an sqlite database.

You should then run the following commands:

```bash
# Install all the dependencies
composer install
# Generate the JWT secret
php artisan jwt:secret
# Create the sqlite database.
touch database/database.sqlite
# Run all the migrations on the database
php artisan migrate
```

To start the development server, you can now run
```
php artisan serve
```

## Generating the API documentation

The API generation can be generated with
```
php artisan l5-swagger:generate
```

Once you start the development server, you can access it at [http://127.0.0.1:8000/api/documentation](http://127.0.0.1:8000/api/documentation)

## Running the unit tests
The unit tests can be run with
```
php artisan test
```

## Running using Docker

To run the API using docker, you first need to copy `.env.docker.example` to `.env.docker` and make the necessary changes.

You can then build the API's Docker container:
```
docker compose build
```

To start the API, run:
```
docker compose up
```

To completely stop it, run:
```
docker compose down
```

You can also use this command to clean the volumes:
```
docker volume rm api_database
docker volume rm api_storage
```

Warning: This will remove all the data used by the API (database and storage).
