<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;

/**
 * @OA\RequestBody(
 *   request="UpdateServer",
 *   required=true,
 *   @OA\JsonContent(
 *     @OA\Property(
 *       property="username",
 *       type="string",
 *       description="Username of the user",
 *     ),
 *     @OA\Property(
 *       property="password",
 *       type="string",
 *       description="Password of the user",
 *     ),
 *     @OA\Property(
 *       property="public",
 *       type="boolean",
 *       description="Whether or not the server should show up in server listing",
 *     ),
 *   ),
 * ),
 */
class UpdateServerRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array<string, mixed>
     */
    public function rules()
    {
        return [
            'login' => 'sometimes|required|string|max:255|unique:servers',
            'password' => 'sometimes|required|string|min:6',
            'public' => 'sometimes|required|boolean'
        ];
    }
}
